/*
 * Copyright (c) 1996 Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#ifndef demkit_h
#define demkit_h

#ifdef VTK

#include <OverlayUnidraw/ovkit.h>

#include <InterViews/defs.h>
#include <Unidraw/enter-scope.h>
#include <InterViews/_enter.h>
#include <InterViews/action.h>

class Canvas;
class MenuItem;
class DemEditor;
class vtkRenderWindow;
class Window;

class DemKit : public OverlayKit {
public:
    DemKit();

    void SetEditor(DemEditor*);
    DemEditor* GetEditor();
    Interactor* Interior();

    virtual void Init(OverlayComp*, const char* name);

    virtual void InitViewer();
    virtual void InitLayout(const char* name);

    virtual Glyph* MakeMenus();
    virtual Glyph* MakeStates();
    virtual Glyph* MakeToolbar();

    virtual MenuItem* MakeFileMenu();
    virtual MenuItem* MakeRepMenu();
    virtual MenuItem* MakeShadeMenu();
    virtual MenuItem* MakeCameraMenu();
    virtual MenuItem* MakeCaptureMenu();
    virtual MenuItem* MakeVehicleMenu();

    static DemKit* Instance();

    void SetXIds(vtkRenderWindow* renwin, Canvas* c); 

  void ShowCameraStateWindow();
  void HideCameraStateWindow();
protected:
  static DemKit* _demkit;

  Window* _camwin;
};

declareActionCallback(DemKit)

#include <InterViews/_leave.h>

#endif

#endif
