/*
 * Copyright 1994, 1995 Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

/*
 * MapKit - object to construct objects for an MapEditor
 */

#ifndef map_kit_h
#define map_kit_h

#include <OverlayUnidraw/ovkit.h>

#include <InterViews/_enter.h>

class GSEditor;
class NameView;
class ThemeChooser;

class MapKit : public OverlayKit {
public:
    MapKit();

    virtual void InitMembers(OverlayComp*);
    virtual void InitLayout(const char* name);
    virtual void InitViewer();
    virtual MenuItem* MakeFileMenu();
    virtual MenuItem* MakeViewMenu();
    virtual Glyph* MakeMenus();
    virtual Glyph* MakeToolbar();
    virtual Glyph* MakeStates();
    Interactor* Interior();
  NameView* ProjNameView() { return _projnameview; }

    static MapKit* Instance();

    virtual void UpdateLayerMenu() {}
    virtual void UpdateLibraryMenu() {}

    GSEditor* gseditor() { return _gseditor; }
    ThemeChooser* thchooser() { return _thchooser; }
protected:
    virtual MenuItem* MakeExportMenu();

    MenuItem* _exportmenu;

    GSEditor* _gseditor;
    ThemeChooser* _thchooser;
  NameView* _projnameview;

    static MapKit* _mapkit;
};

class TelltaleState;

class ShowHideDoer {
public:
    ShowHideDoer(Command* s, Command* h, TelltaleState* st);

    void Do();
public:
    Command* scmd;
    Command* hcmd;
    TelltaleState* state;
};

declareActionCallback(ShowHideDoer)

#include <InterViews/_leave.h>

#endif
