/*
 * Copyright (c) 1998 Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#ifndef projfunc_h
#define projfunc_h

#include <ComTerp/comfunc.h>
#include <ComTerp/comterp.h>

class LoadVpfFCFunc : public ComFunc {
public:
    LoadVpfFCFunc(ComTerp*);
    virtual void execute();
    virtual const char* docstring() { 
      return "fclass=%s(dbpathstr libnamestr covnamestr fcnamestr :tileid tileidnum) -- import a VPF format feature class"; }
protected:
    int _tileid_symid;
};

class GraticuleFCFunc : public ComFunc {
public:
  GraticuleFCFunc(ComTerp*);
  virtual void execute();
  virtual const char* docstring() { 
    return "fclass=%s(:startlon -180.0 :endlon 180.0 :startlat -90.0 :endlat :90.0 :spacing 15.0 :resolution 5.0) -- create a graticule feature class"; }
protected:
  int _startlon_symid, _endlon_symid, _startlat_symid, _endlat_symid,
    _spacing_symid, _resolution_symid;
};

#endif
